/**
 * @defgroup framework-buffer Framework Buffer
 * @{
 * @ingroup framework
 * @brief Buffer exchange mechanism
 * @copyright (C) 2015-2016 CERN (www.cern.ch)
 * @author Federico Vaga <federico.vaga@cern.ch>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TRTL_FW_FRM_BUFFER_H__
#define __TRTL_FW_FRM_BUFFER_H__

/**
 * Description of a buffer that we want to export to the external world
 * (host or network)
 */
struct rt_buffer {
	void *buf; /**< structure location */
	uint32_t len; /**< data structure lenght */
	/* Maybe other option later in time */
};

#endif
/**@}*/
